#include <agb_lib.h>
#include "numbers.h"
#include "objpalette.h"
int score, feel_brave, doornum, gdoor, blah, x, i;
int sram, doorrand;
u16 door;
u16 offset = 0;

typedef struct
{
	u16 xpos;		//x position
	u16 ypos;		//y position
	u16 spriteFrame[9];	//total frames
	int activeFrame;	//which frame is active
}Sprite2;

//Declare some sprites
Sprite2 scorecounter1;
Sprite2 scorecounter2;

void UpdateCounters()
{
	int tens = (score / 10)%10;
	int units = score%10;

	sprites[0].attribute2 = scorecounter1.spriteFrame[units];
	sprites[1].attribute2 = scorecounter2.spriteFrame[tens];
}

int main()
{
	Initialize();
	SetMode(MODE_3|BG2_ENABLE);
	feel_brave=1;
	FadeIn(0);
	doorrand=LoadInt(offset);
	if(doorrand==0)
	{
		doorrand==03;
		SaveInt(offset, 03);
	}
	while(feel_brave==1)
	{
		fillscreen3(0x0000);
		Print(-1, 0, "PREPARING...", RED, BLACK);
		for(i=0;i<doorrand;i++)
		{
			gdoor = rand()%4;
		}
		fillscreen3(0x0000);
		WaitForVblank();
		Sleep(3);
		Print(-1, 0, "GHOST GAME", RED, BLACK);
		WaitForVblank();
		Sleep(3);
		Print(-1, 9, "3 DOORS AHEAD", RED, BLACK);
		WaitForVblank();
		Sleep(3);
		Print(-1, 18, "A GHOST BEHIND ONE", RED, BLACK);
		WaitForVblank();
		Sleep(3);
		Print(-1, 27, "WHICH DOOR DO YOU CHOOSE?", RED, BLACK);
		WaitForVblank();
		Sleep(3);
		Print(-1, 36, "UP, LEFT, OR RIGHT?", RED, BLACK);
		WaitForVblank();
		Sleep(3);
		while(NOT((keyDown(KEY_UP))OR(keyDown(KEY_LEFT))OR(keyDown(KEY_RIGHT))))
		{
			blah=0;
		}
		if(keyDown(KEY_UP))
		{
			doornum=1;
		}
		if(keyDown(KEY_LEFT))
		{
			doornum=2;
		}
		if(keyDown(KEY_RIGHT))
		{
			doornum=3;
		}
		if(doornum==gdoor)
		{
			SetMode(MODE_3|BG2_ENABLE|OBJ_ENABLE|OBJ_MAP_1D);
			fillscreen3(0x0000);	
			WaitForVblank();
			Sleep(25);
			Print(0, 0, "GHOST! RUN AWAY!", RED, BLACK);
			WaitForVblank();
			Sleep(3);
			Print(0, 9, "GAME OVER! YOU SCORED:   .", RED, BLACK);
			WaitForVblank();
			Sleep(3);
			Print(0, 18, "PRESS ANY BUTTON TO RESET.", RED, BLACK);
			Print(0, 152, "GET REKT M80.", 0x0C63, BLACK);
			Sleep(127.5);
			vsync
			sprites[0].attribute0 = COLOR_256 | SQUARE | 9;
			sprites[0].attribute1 = SIZE_8 | 192;
			sprites[0].attribute2 = 1188;			//pointer to tile where sprite starts

			scorecounter1.spriteFrame[0] = 594;
			scorecounter1.spriteFrame[1] = 596;
			scorecounter1.spriteFrame[2] = 598;
			scorecounter1.spriteFrame[3] = 600;
			scorecounter1.spriteFrame[4] = 602;
			scorecounter1.spriteFrame[5] = 604;
			scorecounter1.spriteFrame[6] = 606;
			scorecounter1.spriteFrame[7] = 608;
			scorecounter1.spriteFrame[8] = 610;
			scorecounter1.spriteFrame[9] = 612;
			scorecounter1.activeFrame = 1188;

			//score counter 2
			sprites[1].attribute0 = COLOR_256 | SQUARE | 9;
			sprites[1].attribute1 = SIZE_8 | 184;
			sprites[1].attribute2 = 1188;			//pointer to tile where sprite starts

			scorecounter2.spriteFrame[0] = 594;
			scorecounter2.spriteFrame[1] = 596;
			scorecounter2.spriteFrame[2] = 598;
			scorecounter2.spriteFrame[3] = 600;
			scorecounter2.spriteFrame[4] = 602;
			scorecounter2.spriteFrame[5] = 604;
			scorecounter2.spriteFrame[6] = 606;
			scorecounter2.spriteFrame[7] = 608;
			scorecounter2.spriteFrame[8] = 610;
			scorecounter2.spriteFrame[9] = 612;
			scorecounter2.activeFrame = 1188;
			loadSpritePal((void*)OBJPalette);
			//load numbers zero to nine
			SaveInt(offset, doorrand+(score*5));
			for(x = 9504; x < 9824; x++)
			{
				OAMData[x] = numbers2Data[x-9504];
			}
			UpdateCounters();
			while(1)
			{
				CopyOAM();
				if(KEY_ANY_PRESSED)
				{
					hardreset();
				}
			}
		} else {
			fillscreen3(0x0000);
			WaitForVblank();
			Sleep(8);
			Print(-1, 0, "NO GHOST!", RED, BLACK);
			score++;	
			while(NOT(keyDown(KEY_A)));	
		}
	}
	
	return 0;
}
